<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::ComponentListIterator&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1ComponentListIterator.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1ComponentListIterator-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::ComponentListIterator&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class used to iterate over subcomponents of a specific type (by default, any <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>).  
 <a href="classOpenSim_1_1ComponentListIterator.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::ComponentListIterator&lt; T &gt;:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1ComponentListIterator.png" alt=""/>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a93f5af4260ee7fe7e2395af67743c998"><td class="memTemplParams" colspan="2">template&lt;typename OtherT &gt; </td></tr>
<tr class="memitem:a93f5af4260ee7fe7e2395af67743c998"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a93f5af4260ee7fe7e2395af67743c998">operator==</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; OtherT &gt; &amp;other) const</td></tr>
<tr class="memdesc:a93f5af4260ee7fe7e2395af67743c998"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check that the component under the current iterator is the same (has same address) as the right-hand iterator.  <a href="classOpenSim_1_1ComponentListIterator.html#a93f5af4260ee7fe7e2395af67743c998">More...</a><br /></td></tr>
<tr class="separator:a93f5af4260ee7fe7e2395af67743c998"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff419711065b54c431e629c590495257"><td class="memTemplParams" colspan="2">template&lt;typename OtherT &gt; </td></tr>
<tr class="memitem:aff419711065b54c431e629c590495257"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#aff419711065b54c431e629c590495257">operator!=</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; OtherT &gt; &amp;other) const</td></tr>
<tr class="memdesc:aff419711065b54c431e629c590495257"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check for inequality using same convention as operator==.  <a href="classOpenSim_1_1ComponentListIterator.html#aff419711065b54c431e629c590495257">More...</a><br /></td></tr>
<tr class="separator:aff419711065b54c431e629c590495257"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32e2ef76e640f4f4fe5ffa02ec1dbc6f"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a32e2ef76e640f4f4fe5ffa02ec1dbc6f">operator*</a> () const</td></tr>
<tr class="memdesc:a32e2ef76e640f4f4fe5ffa02ec1dbc6f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Dereference the iterator to get a reference to <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> of proper type (matching Filter if specified).  <a href="classOpenSim_1_1ComponentListIterator.html#a32e2ef76e640f4f4fe5ffa02ec1dbc6f">More...</a><br /></td></tr>
<tr class="separator:a32e2ef76e640f4f4fe5ffa02ec1dbc6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d0d0584f25daee00787320cec36c849"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a0d0d0584f25daee00787320cec36c849">deref</a> () const</td></tr>
<tr class="separator:a0d0d0584f25daee00787320cec36c849"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a023d6c8b06c241d0d93a051e7ce58206"><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a023d6c8b06c241d0d93a051e7ce58206">operator-&gt;</a> () const</td></tr>
<tr class="memdesc:a023d6c8b06c241d0d93a051e7ce58206"><td class="mdescLeft">&#160;</td><td class="mdescRight">Another dereferencing operator that returns a pointer.  <a href="classOpenSim_1_1ComponentListIterator.html#a023d6c8b06c241d0d93a051e7ce58206">More...</a><br /></td></tr>
<tr class="separator:a023d6c8b06c241d0d93a051e7ce58206"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1702fa5851a394e074684fb3a8f8980b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a1702fa5851a394e074684fb3a8f8980b">operator++</a> ()</td></tr>
<tr class="memdesc:a1702fa5851a394e074684fb3a8f8980b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prefix increment operator to get the next item in the <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a>.  <a href="classOpenSim_1_1ComponentListIterator.html#a1702fa5851a394e074684fb3a8f8980b">More...</a><br /></td></tr>
<tr class="separator:a1702fa5851a394e074684fb3a8f8980b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a741ccbfddf2394fcdc3fec183ba6aa2f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a741ccbfddf2394fcdc3fec183ba6aa2f">operator++</a> (int)</td></tr>
<tr class="memdesc:a741ccbfddf2394fcdc3fec183ba6aa2f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Postfix increment operator to get the next item in the <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a>.  <a href="classOpenSim_1_1ComponentListIterator.html#a741ccbfddf2394fcdc3fec183ba6aa2f">More...</a><br /></td></tr>
<tr class="separator:a741ccbfddf2394fcdc3fec183ba6aa2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb83a34535c7a58de24bee63e38cada7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#adb83a34535c7a58de24bee63e38cada7">next</a> ()</td></tr>
<tr class="memdesc:adb83a34535c7a58de24bee63e38cada7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method equivalent to pre-increment operator for operator-deficient languages.  <a href="classOpenSim_1_1ComponentListIterator.html#adb83a34535c7a58de24bee63e38cada7">More...</a><br /></td></tr>
<tr class="separator:adb83a34535c7a58de24bee63e38cada7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc762b5f960dd22e3223ed5027539920"><td class="memTemplParams" colspan="2">template&lt;typename FromT &gt; </td></tr>
<tr class="memitem:acc762b5f960dd22e3223ed5027539920"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#acc762b5f960dd22e3223ed5027539920">ComponentListIterator</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; FromT &gt; &amp;source, typename std::enable_if&lt; std::is_convertible&lt; FromT *, T * &gt;::value &gt;::type *=0)</td></tr>
<tr class="memdesc:acc762b5f960dd22e3223ed5027539920"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allow converting from non-const iterator to const_iterator.  <a href="classOpenSim_1_1ComponentListIterator.html#acc762b5f960dd22e3223ed5027539920">More...</a><br /></td></tr>
<tr class="separator:acc762b5f960dd22e3223ed5027539920"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:ae4c3a092f6dc366d9f652bdd420b3c04"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#ae4c3a092f6dc366d9f652bdd420b3c04">equals</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> &amp;other) const</td></tr>
<tr class="memdesc:ae4c3a092f6dc366d9f652bdd420b3c04"><td class="mdescLeft">&#160;</td><td class="mdescRight">@ Comparison operators for scripting These variants accept only an iterator with the same template parameter.  <a href="classOpenSim_1_1ComponentListIterator.html#ae4c3a092f6dc366d9f652bdd420b3c04">More...</a><br /></td></tr>
<tr class="separator:ae4c3a092f6dc366d9f652bdd420b3c04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abed4486bb5c3036f0d7a14960b982d69"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#abed4486bb5c3036f0d7a14960b982d69">operator==</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> &amp;other) const</td></tr>
<tr class="separator:abed4486bb5c3036f0d7a14960b982d69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cce749e2f5f70b6933dce28f404959b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a1cce749e2f5f70b6933dce28f404959b">operator!=</a> (const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> &amp;other) const</td></tr>
<tr class="separator:a1cce749e2f5f70b6933dce28f404959b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:abde55dc1245bf6a5d93526aee303cd7e"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#abde55dc1245bf6a5d93526aee303cd7e">ComponentList&lt; T &gt;</a></td></tr>
<tr class="separator:abde55dc1245bf6a5d93526aee303cd7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ce1b1884796ef0e8f8e6fe648b16741"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#a1ce1b1884796ef0e8f8e6fe648b16741">ComponentList&lt; NonConstT &gt;</a></td></tr>
<tr class="separator:a1ce1b1884796ef0e8f8e6fe648b16741"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3b7be25bccd203f15efd8e01dae4608"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#aa3b7be25bccd203f15efd8e01dae4608">ComponentListIterator&lt; ConstT &gt;</a></td></tr>
<tr class="separator:aa3b7be25bccd203f15efd8e01dae4608"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acdabac4f5771487e2edd7dbad16276e4"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentListIterator.html#acdabac4f5771487e2edd7dbad16276e4">ComponentListIterator&lt; NonConstT &gt;</a></td></tr>
<tr class="separator:acdabac4f5771487e2edd7dbad16276e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
class OpenSim::ComponentListIterator&lt; T &gt;</h3>

<p>Class used to iterate over subcomponents of a specific type (by default, any <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>). </p>
<p>This iterator is can either be a const_iterator or non-const iterator, depending on how you got it. If this is a const_iterator, it returns only a const reference to a component. If this is a non-const iterator, then it returns a non-const reference to a component, and thus you can modify the component.</p>
<p>If you got this iterator from something like a ComponentList&lt;const Body&gt;, then it is necessarily a const_iterator. If you got this iterator from something like ComponentList&lt;Body&gt;, then this may be either a const_iterator (e.g., from <a class="el" href="classOpenSim_1_1ComponentList.html#a9c9ca2c2b77e2e144c62cc9bf5231c1a" title="Similar to begin(), except it does not permit modifying the elements of the list, even if T is non-co...">ComponentList&lt;Body&gt;::cbegin()</a>) or non-const iterator (e.g., from <a class="el" href="classOpenSim_1_1ComponentList.html#a1104cce4a365cadfee59d7078d75ca59" title="Return an iterator pointing to the first component in the tree traversal of components under and incl...">ComponentList&lt;Body&gt;::begin()</a>).</p>
<p>If you have a non-const iterator, you should <em>not</em> add (sub)components to any components.</p>
<p>This iterator works only in the forward direction (not bidirectional).</p>
<p>Here is an example of using this iterator with a range for loop (const_iterator): </p><div class="fragment"><div class="line">ComponentList&lt;const GeometryPath&gt; geomPathList = model.getComponentList&lt;GeometryPath&gt;();</div>
<div class="line"><span class="keywordflow">for</span> (<span class="keyword">const</span> GeometryPath&amp; gpath : geomPathList) {</div>
<div class="line">    <span class="comment">// do something with gpath</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>Here is a similar example, but where you can modify the components: </p><div class="fragment"><div class="line">ComponentList&lt;GeometryPath&gt; geomPathList = model.updComponentList&lt;GeometryPath&gt;();</div>
<div class="line"><span class="keywordflow">for</span> (GeometryPath&amp; gpath : geomPathList) {</div>
<div class="line">    <span class="comment">// do something with gpath</span></div>
<div class="line">}</div>
</div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="acc762b5f960dd22e3223ed5027539920"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acc762b5f960dd22e3223ed5027539920">&#9670;&nbsp;</a></span>ComponentListIterator()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<div class="memtemplate">
template&lt;typename FromT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; FromT &gt; &amp;&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename std::enable_if&lt; std::is_convertible&lt; FromT *, T * &gt;::value &gt;::type *&#160;</td>
          <td class="paramname"> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Allow converting from non-const iterator to const_iterator. </p>
<p>This helps with iterating through the list in a const way, even if you have a non-const list. This allows the following code: </p><div class="fragment"><div class="line">ComponentList&lt;Body&gt; bodies = model.getComponentList&lt;Body&gt;();</div>
<div class="line"><a class="code" href="classOpenSim_1_1ComponentList.html#ad84ce07e23b1196eed15069fdd888d7f">ComponentList&lt;Body&gt;::const_iterator</a> = bodies.begin();</div>
<div class="ttc" id="aclassOpenSim_1_1ComponentList_html_ad84ce07e23b1196eed15069fdd888d7f"><div class="ttname"><a href="classOpenSim_1_1ComponentList.html#ad84ce07e23b1196eed15069fdd888d7f">OpenSim::ComponentList::const_iterator</a></div><div class="ttdeci">ComponentListIterator&lt; ConstT &gt; const_iterator</div><div class="ttdoc">A const forward iterator for iterating through ComponentList&lt;T&gt;.</div><div class="ttdef"><b>Definition:</b> ComponentList.h:127</div></div>
</div><!-- fragment --><p> This constructor does <em>not</em> allow converting from a const_iterator to a non-const iterator (through the enable_if). </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a0d0d0584f25daee00787320cec36c849"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d0d0584f25daee00787320cec36c849">&#9670;&nbsp;</a></span>deref()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::deref </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a023d6c8b06c241d0d93a051e7ce58206">OpenSim::ComponentListIterator&lt; T &gt;::operator-&gt;()</a>.</p>

</div>
</div>
<a id="ae4c3a092f6dc366d9f652bdd420b3c04"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae4c3a092f6dc366d9f652bdd420b3c04">&#9670;&nbsp;</a></span>equals()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::equals </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>@ Comparison operators for scripting These variants accept only an iterator with the same template parameter. </p>
<p>Check for (non)equality using a normal method rather than an operator. </p>

</div>
</div>
<a id="adb83a34535c7a58de24bee63e38cada7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb83a34535c7a58de24bee63e38cada7">&#9670;&nbsp;</a></span>next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&amp; <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Method equivalent to pre-increment operator for operator-deficient languages. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a741ccbfddf2394fcdc3fec183ba6aa2f">OpenSim::ComponentListIterator&lt; T &gt;::operator++()</a>.</p>

</div>
</div>
<a id="a1cce749e2f5f70b6933dce28f404959b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cce749e2f5f70b6933dce28f404959b">&#9670;&nbsp;</a></span>operator!=() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aff419711065b54c431e629c590495257"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff419711065b54c431e629c590495257">&#9670;&nbsp;</a></span>operator!=() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<div class="memtemplate">
template&lt;typename OtherT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; OtherT &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Check for inequality using same convention as operator==. </p>

</div>
</div>
<a id="a32e2ef76e640f4f4fe5ffa02ec1dbc6f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a32e2ef76e640f4f4fe5ffa02ec1dbc6f">&#9670;&nbsp;</a></span>operator*()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator* </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Dereference the iterator to get a reference to <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> of proper type (matching Filter if specified). </p>
<p>If you have a const iterator, then this returns a const reference; otherwise, this returns a non-const reference. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a023d6c8b06c241d0d93a051e7ce58206">OpenSim::ComponentListIterator&lt; T &gt;::operator-&gt;()</a>.</p>

</div>
</div>
<a id="a1702fa5851a394e074684fb3a8f8980b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1702fa5851a394e074684fb3a8f8980b">&#9670;&nbsp;</a></span>operator++() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; T &gt; &amp; <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator++</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prefix increment operator to get the next item in the <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a>. </p>
<p>ComponentListIterator&lt;T&gt; pre-increment operator, advances the iterator to the next valid entry.</p>
<p>Prefer to use ++iter and not iter++. </p>

</div>
</div>
<a id="a741ccbfddf2394fcdc3fec183ba6aa2f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a741ccbfddf2394fcdc3fec183ba6aa2f">&#9670;&nbsp;</a></span>operator++() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a> <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator++ </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Postfix increment operator to get the next item in the <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a>. </p>
<p>To enable usage as iter++, although ++iter is more efficient. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1ComponentListIterator.html#adb83a34535c7a58de24bee63e38cada7">OpenSim::ComponentListIterator&lt; T &gt;::next()</a>.</p>

</div>
</div>
<a id="a023d6c8b06c241d0d93a051e7ce58206"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a023d6c8b06c241d0d93a051e7ce58206">&#9670;&nbsp;</a></span>operator-&gt;()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator-&gt; </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Another dereferencing operator that returns a pointer. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a0d0d0584f25daee00787320cec36c849">OpenSim::ComponentListIterator&lt; T &gt;::deref()</a>, and <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a32e2ef76e640f4f4fe5ffa02ec1dbc6f">OpenSim::ComponentListIterator&lt; T &gt;::operator*()</a>.</p>

</div>
</div>
<a id="abed4486bb5c3036f0d7a14960b982d69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abed4486bb5c3036f0d7a14960b982d69">&#9670;&nbsp;</a></span>operator==() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a93f5af4260ee7fe7e2395af67743c998"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93f5af4260ee7fe7e2395af67743c998">&#9670;&nbsp;</a></span>operator==() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<div class="memtemplate">
template&lt;typename OtherT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1ComponentListIterator.html">OpenSim::ComponentListIterator</a>&lt; T &gt;::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; OtherT &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Check that the component under the current iterator is the same (has same address) as the right-hand iterator. </p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a1ce1b1884796ef0e8f8e6fe648b16741"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ce1b1884796ef0e8f8e6fe648b16741">&#9670;&nbsp;</a></span>ComponentList&lt; NonConstT &gt;</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOpenSim_1_1ComponentList.html">ComponentList</a>&lt; NonConstT &gt;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This is required to allow <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a>&lt;non-const T&gt;::begin() to construct a <code><a class="el" href="classOpenSim_1_1ComponentListIterator.html" title="Class used to iterate over subcomponents of a specific type (by default, any Component).">ComponentListIterator</a>&lt;const T&gt;</code> (that is, const_iterator). </p>

</div>
</div>
<a id="abde55dc1245bf6a5d93526aee303cd7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abde55dc1245bf6a5d93526aee303cd7e">&#9670;&nbsp;</a></span>ComponentList&lt; T &gt;</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOpenSim_1_1ComponentList.html">ComponentList</a>&lt; T &gt;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Allow <a class="el" href="classOpenSim_1_1ComponentList.html" title="Collection (linked list) of components to iterate through.">ComponentList</a> to use the private constructor of this class. </p>

</div>
</div>
<a id="aa3b7be25bccd203f15efd8e01dae4608"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa3b7be25bccd203f15efd8e01dae4608">&#9670;&nbsp;</a></span>ComponentListIterator&lt; ConstT &gt;</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; ConstT &gt;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>ComponentListIterator&lt;const T&gt; needs access to the members of ComponentListIterator&lt;T&gt; for the templated constructor above. </p>

</div>
</div>
<a id="acdabac4f5771487e2edd7dbad16276e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acdabac4f5771487e2edd7dbad16276e4">&#9670;&nbsp;</a></span>ComponentListIterator&lt; NonConstT &gt;</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a>&lt; NonConstT &gt;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Comparison operators for ComponentListIterator&lt;T&gt; need access to members of ComponentListIterator&lt;const T&gt; (e.g., when invoking <a class="el" href="classOpenSim_1_1ComponentListIterator.html#a93f5af4260ee7fe7e2395af67743c998" title="Check that the component under the current iterator is the same (has same address) as the right-hand ...">operator==()</a> with a ComponentListIterator&lt;T&gt; as the left operand and a ComponentListIterator&lt;const T&gt; as the right operand). </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>OpenSim/Common/ComponentList.h</li>
<li>OpenSim/Common/Component.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1ComponentListIterator.html">ComponentListIterator</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:19 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
